////////////////////////////////////////////////////////////////////////
// whats_on.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.whats_on")

// <%pre>
#line 1 "whats_on.ecpp"


#include <livefeatures.h>
#include <setup.h>
#include <tools.h>
#include <epg_events.h>
#include <epgsearch.h>

using namespace vdrlive;

static const size_t maximumTruncDescriptionLength = 150;  // characters for the description in the "boxes"


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class whats_on_actions_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        whats_on_actions_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    whats_on_actions_type whats_on_actions;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("whats_on");

static const char* rawData = "\000\000\001T\000\000\001U\000\000\001V\000\000\001W\000\000\001\302\000\000\001\315\000"
  "\000\001\320\000\000\001\325\000\000\002\225\000\000\003T\000\000\003\313\000\000\003\316\000\000\003\346\000\000\004"
  "m\000\000\004\217\000\000\004\363\000\000\004\365\000\000\004\366\000\000\005Q\000\000\005\247\000\000\005\277\000"
  "\000\005\355\000\000\006\036\000\000\006I\000\000\006z\000\000\006\201\000\000\006\250\000\000\006\251\000\000\006"
  "\270\000\000\006\331\000\000\006\345\000\000\007\000\000\000\007D\000\000\007l\000\000\007\251\000\000\007\254\000"
  "\000\007\331\000\000\007\337\000\000\007\340\000\000\007\373\000\000\010\034\000\000\010(\000\000\010M\000\000\010N"
  "\000\000\010\207\000\000\010\310\000\000\010\312\000\000\010\313\000\000\010\351\000\000\010\365\000\000\t\017\000"
  "\000\t\020\000\000\t\021\000\000\t\023\000\000\t\035\000\000\tE\000\000\tT\000\000\t~\000\000\t\247\000\000\t\267\000"
  "\000\t\344\000\000\t\346\000\000\nU\000\000\n^\000\000\ne\000\000\nh\000\000\nr\000\000\n\244\000\000\n\246\000\000\n"
  "\361\000\000\013.\000\000\0138\000\000\013a\000\000\013c\000\000\013\203\000\000\013\257\000\000\013\273\000\000\013"
  "\310\000\000\013\312\000\000\013\317\000\000\013\371\000\000\014\005\000\000\014\022\000\000\014\024\000\000\014\031"
  "\n\n\n\n<html>\n\t<head>\n<meta name=\"viewport\" content=\"width=device-width, initial-scale=1\" />\n\t\t<title>VDR-"
  "Live - </title>\n\t\t\n\t\t\n    \n\t\t<script type=\"text/javascript\"><!--\n\t\tfunction showtime(selection)\n\t\t{"
  "\n\t\t\tif (selection.options[selection.selectedIndex].value != \"\")\n\t\t\t\twindow.location.href = \"whats_on.html"
  "\?type=at&mode=&fixtime=\" + selection.options[selection.selectedIndex].value;\n\t\t}\n\t\tfunction showspectime(sele"
  "ction)\n\t\t{\n\t\t\tif (selection.value != \"\")\n\t\t\t\twindow.location.href = \"whats_on.html\?type=at&mode=&atti"
  "me=\" + selection.value;\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload=\"adjustHeader()\" onresize=\"adjustHe"
  "ader()\">\n\t\t\n\t\t\n\t\t<div class=\"inhalt\">\n\t\t\t<table class=\"listing\" cellspacing=\"0\" cellpadding=\"0\""
  ">\n\t\t\t\t<tr class=\"head\">\n\t\t\t\t\t<td colspan=\"9\"><div class=\"boxheader\"><div><div></div></div></div></td"
  ">\n\t\t\t\t</tr>\n\t\t\t<div class=\"event\">\n\t\t\t\t<div class=\"station\">\n\t\t\t\t\t<div><div><div><a href=\"sc"
  "hedule.html\?channel=\" ></a></div></div></div>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"content\">\n\t\t\t\t\t<div clas"
  "s=\"tools\">\n\t\t\t\t\t\t\n\t\t\t\t\t</div>\n\t\t\t\t\t<div>\n\t\t\t\t\t\t<div class=\"info nowrap\"><div class=\"da"
  "te margin_right\"></div><div class=\"time\"></div></div>\n\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t"
  "\t\t\t\t<div class=\"title withmargin\"></div>\n\t\t\t\t\t\t<div class=\"short withmargin\"></div>\n\t\t\t\t\t\t<div "
  "class=\"description withmargin\"></div>\n\t\t\t\t\t\t\t<div class=\"more withmargin\"><a > ...</a></div>\n\t\t\t\t\t<"
  "/div>\n\t\t\t\t</div>\n\t\t\t</div>\n\t\t\t<tr>\n\t\t\t\t\n\t\t\t\t<td class=\"topaligned \">\n\t\t\t\t\t<div class="
  "\"withmargin\">\n\t\t\t\t\t\t<div class=\"nomargin nowrap\"></div>\n\t\t\t\t\t\t<div class=\"progress\"><div></div></"
  "div>\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class=\"topaligned \">\n\t\t\t\t\t\t<div class=\"more withmargin\""
  ">\n\t\t\t\t\t\t<a\n\t\t\t\t\t\t\n\t\t\t\t\t\t><span class=\"title\"></span><br /><span class=\"short\"></span></a>\n"
  "\t\t\t\t\t\t<div class=\"withmargin\">\n\t\t\t\t\t\t\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class=\"topaligned"
  " rightcol \"><div class=\"station withmargin\"><a href=\"schedule.html\?channel=\" ></a></div>\n\t\t\t\t</td>\n\t\t\t"
  "</tr>\n\t\t\t</table>\n\t\t</div>\n\t</body>\n</html>\n\n\n\n\n<a class=\"\" href=\"whats_on.html\?type=now&amp;mode="
  "\" id=\"nowhref\"></a>\n<span class=\"sep\">|</span>\n<a class=\"\" href=\"whats_on.html\?type=next&amp;mode=\" id=\""
  "nexthref\"></a>\n<span class=\"sep\">|</span>\n<span class=\"\"></span>\n<select name=\"userdeftimes\" size=\"1\" id="
  "\"userdeftimes\" onchange=\"showtime(this)\">\n\t<option value=\"0\"/>\n\t<option value=\"\"> </option>\n</select>\n<"
  "span class=\"sep\">|</span>\n<span class=\"\"></span>\n<input type=\"text\" size=\"6\" name=\"spectime\" id=\"spectim"
  "e\" value = \"\" onchange=\"showspectime(this)\"/>\n<span class=\"sep\">|</span>\n<a class=\"\" href=\"whats_on.html"
  "\?type=favs&amp;mode=\"></a>\n<span class=\"sep\">|</span>\n<a href=\"whats_on.html\?mode=detail&amp;type=&amp;attime"
  "=&amp;fixtime=\"></a>\n<a href=\"whats_on.html\?mode=list&amp;type=&amp;attime=&amp;fixtime=\"></a>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    whats_on_actions(*this, "whats_on_actions")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string type = qparam.get< std::string >("type", ( "now"));
std::string mode = qparam.get< std::string >("mode");
std::string attime = qparam.get< std::string >("attime");
std::string fixtime = qparam.get< std::string >("fixtime");
  // </%args>

#line 21 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 26 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 27 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 28 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 29 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 30 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 34 "whats_on.ecpp"

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");


std::string head;
time_t seektime = 0;
std::string displaytime;
std::string headTime;
std::string headDate;

if (mode.empty())
	mode = LiveSetup().GetLastWhatsOnListMode();
else
	LiveSetup().SetLastWhatsOnListMode(mode);

current_type = type;
current_mode = mode;
current_attime = attime;
current_fixtime = fixtime;

char const * timeFormat = tr("%I:%M %p");
char const * dateFormat = tr("%A, %x");
if (mode == "detail") {
	dateFormat = tr("%a, %x");
}

if (type == "now") {
	headTime = std::string(cToSvDateTime(timeFormat, time(0)));
	headDate = std::string(cToSvDateTime(dateFormat, time(0)));
	head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + " " + headTime;
} else if (type == "next") {
	headTime = std::string(cToSvDateTime(timeFormat, time(0) + 3600));
	headDate = std::string(cToSvDateTime(dateFormat, time(0) + 3600));
	head = tr("What's on next?");
} else if (type == "at") {
	if (attime != "")
		displaytime = ExpandTimeString(attime);
	else if (fixtime != "")
		displaytime = ExpandTimeString(fixtime);
	current_displaytime = displaytime;

	seektime = GetTimeT(displaytime);
	if (seektime - time(0) + 3600 < 0) // if wanted time is past more then 1h, then use tomorrow
		seektime += SECSINDAY;
	headTime = std::string(cToSvDateTime(timeFormat, seektime));
	headDate = std::string(cToSvDateTime(dateFormat, seektime));
	head = std::string(tr("What's running on")) + " " + headDate + " " + tr("at") + std::string(" ") + headTime;
} else if (type == "favs") {
	head = tr("Favorites");
}


  // <& pageelems.doc_type ...
  { 
#line 87 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 87 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n\t<head>\n<meta name="viewport" content="width=device-width, initial-scale=1" />\n\t\t<title>VDR-Live - 
#line 91 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[4]; // </title>\n\t\t
  // <& pageelems.stylesheets ...
  { 
#line 92 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 92 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n\t\t
  // <& pageelems.ajax_js ...
  { 
#line 93 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 93 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 94 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 94 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n\t\t<script type="text/javascript"><!--\n\t\tfunction showtime(selection)\n\t\t{\n\t\t\tif (selection.options[selection.selectedIndex].value != "")\n\t\t\t\twindow.location.href = "whats_on.html\?type=at&mode=
#line 99 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[8]; // &fixtime=" + selection.options[selection.selectedIndex].value;\n\t\t}\n\t\tfunction showspectime(selection)\n\t\t{\n\t\t\tif (selection.value != "")\n\t\t\t\twindow.location.href = "whats_on.html\?type=at&mode=
#line 104 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[9]; // &attime=" + selection.value;\n\t\t}\n\t\t//--></script>\n\t</head>\n\t<body onload="adjustHeader()" onresize="adjustHeader()">\n\t\t
  // <& pageelems.logo ...
  { 
#line 109 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 109 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[10]; // \n\t\t
  // <& menu ...
  { 
#line 110 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 110 "whats_on.ecpp"
    _tnt_cq5.add( "active", ("whats_on"));
#line 110 "whats_on.ecpp"
    _tnt_cq5.add( "component", ("whats_on.whats_on_actions"));
#line 110 "whats_on.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[11]; // \n\t\t<div class="inhalt">\n
#line 112 "whats_on.ecpp"
			if (mode == "list") {

  reply.out() << _tntChunks[12]; // \t\t\t<table class="listing" cellspacing="0" cellpadding="0">\n\t\t\t\t<tr class="head">\n\t\t\t\t\t<td colspan="9"><div class="boxheader"><div><div>
#line 115 "whats_on.ecpp"
  reply.sout() << ( head );
  reply.out() << _tntChunks[13]; // </div></div></div></td>\n\t\t\t\t</tr>\n
#line 117 "whats_on.ecpp"
	    }

#line 118 "whats_on.ecpp"

	std::list<EpgInfoPtr> eventList;

	// collect the broadcasts
	if (type != "favs")
	{
		LOCK_CHANNELS_READ;
		{
			for (cChannel *Channel = (cChannel *)Channels->First(); Channel && Channel->Number() <= LiveSetup().GetLastChannel(); Channel = (cChannel *)Channels->Next(Channel)) {
				if (Channel->GroupSep()) {
					continue;
				}
				const cSchedule *Schedule;
				{
					LOCK_SCHEDULES_READ;
					Schedule = Schedules->GetSchedule(Channel);
				}
				if (!Schedule) {
					continue;
				}
				const cEvent *Event = NULL;
				if (type == "now")
					Event = Schedule->GetPresentEvent();
				else if (type == "next")
					Event = Schedule->GetFollowingEvent();
				else if (type == "at")
					Event = Schedule->GetEventAround(seektime);

				if (!Event && !LiveSetup().GetShowChannelsWithoutEPG()) continue;

				EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, Event);
				eventList.push_back(epgEvent);
			}
		}
	}
	else // get favorite broadcasts from epgsearch
	{
		SearchResults results;
		SearchTimers timers;
		for (SearchTimers::iterator timer = timers.begin(); timer != timers.end(); ++timer) {
			if (!timer->UseInFavorites()) continue;
			SearchResults curresults;
			curresults.GetByID(timer->Id());
			results.merge(curresults);
		}
		time_t now = time(NULL);
		for (SearchResults::iterator result = results.begin(); result != results.end(); ++result) {
			long diff = result->StartTime() - now;
			if (labs(diff) >= 24*60*60) continue; // skip broadcasts more than a day away
			const cChannel* Channel = result->GetChannel();
			if (!Channel) continue;
			EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(Channel, result->GetEvent(Channel));
			eventList.push_back(epgEvent);
		}
	}

	// display broadcasts
	for(std::list<EpgInfoPtr>::iterator i = eventList.begin(); i != eventList.end(); ++i ) {
		EpgInfoPtr epgEvent = *i;

		bool truncated = false;
		std::string truncDescription(StringWordTruncate(epgEvent->LongDescr(), maximumTruncDescriptionLength, truncated));
		std::string longDescription = StringEscapeAndBreak(StringWordTruncate(epgEvent->LongDescr(), LiveSetup().GetMaxTooltipChars()))
			+ "<br/><br/>" + tr("Click to view details.");
		const cChannel* Channel = epgEvent->Channel();
		if (!Channel) continue;
		int chNumber = Channel->Number();

		std::string startTime(epgEvent->StartTime(tr("%I:%M %p")));
		std::string endTime(epgEvent->EndTime(tr("%I:%M %p")));
		std::string startDate(epgEvent->StartTime(tr("%a, %x")));

		std::string timeSpan(startTime + " - " + endTime);

		if (startTime.empty() && endTime.empty()) {
			timeSpan = mode=="detail" ? headTime : std::string();
			startDate = headDate;
		}
		if (mode == "detail") {

  reply.out() << _tntChunks[14]; // \t\t\t<div class="event">\n\t\t\t\t<div class="station">\n\t\t\t\t\t<div><div><div><a href="schedule.html\?channel=
#line 200 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
  reply.out() << _tntChunks[15]; // " 
  // <& tooltip.hint ...
  { 
#line 200 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 200 "whats_on.ecpp"
    _tnt_cq6.add( "text", (tr("View the schedule of this channel")));
#line 200 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[16]; // >
#line 200 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
#line 200 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
#line 200 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Caption()) );
  reply.out() << _tntChunks[17]; // </a></div></div></div>\n\t\t\t\t</div>\n\t\t\t\t<div class="content">\n\t\t\t\t\t<div class="tools">\n\t\t\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 204 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 204 "whats_on.ecpp"
    _tnt_cq7.add( "detail", (1));
#line 204 "whats_on.ecpp"
    _tnt_cq7.add( "endTime", (epgEvent->GetEndTime()));
#line 204 "whats_on.ecpp"
    _tnt_cq7.add( "epgid", (epgEvent->Id()));
#line 204 "whats_on.ecpp"
    _tnt_cq7.add( "startTime", (epgEvent->GetStartTime()));
#line 204 "whats_on.ecpp"
    _tnt_cq7.add( "title", (epgEvent->Title()));
#line 204 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[18]; // \n\t\t\t\t\t</div>\n\t\t\t\t\t<div>\n\t\t\t\t\t\t<div class="info nowrap"><div class="date margin_right">
#line 207 "whats_on.ecpp"
  reply.sout() << ( (startDate) );
  reply.out() << _tntChunks[19]; // </div><div class="time">
#line 207 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[20]; // </div></div>\n\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 208 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 208 "whats_on.ecpp"
    _tnt_cq8.add( "duration", (epgEvent->Duration()));
#line 208 "whats_on.ecpp"
    _tnt_cq8.add( "progress", (epgEvent->Elapsed()));
#line 208 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[21]; // </div></div>\n\t\t\t\t\t\t<div class="title withmargin">
#line 209 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[22]; // </div>\n\t\t\t\t\t\t<div class="short withmargin">
#line 210 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[23]; // </div>\n\t\t\t\t\t\t<div class="description withmargin">
#line 211 "whats_on.ecpp"
  reply.sout() << ( truncDescription );
  reply.out() << _tntChunks[24]; // </div>\n
#line 212 "whats_on.ecpp"
						if (truncated) {

  reply.out() << _tntChunks[25]; // \t\t\t\t\t\t\t<div class="more withmargin"><a 
  // <& tooltip.hint ...
  { 
#line 213 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 213 "whats_on.ecpp"
    _tnt_cq9.add( "text", (longDescription));
#line 213 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 213 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 213 "whats_on.ecpp"
    _tnt_cq10.add( "domId", (epgEvent->Id()));
#line 213 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[26]; // >
#line 213 "whats_on.ecpp"
  reply.sout() << ( 	tr("more") );
  reply.out() << _tntChunks[27]; //  ...</a></div>\n
#line 214 "whats_on.ecpp"
						}

  reply.out() << _tntChunks[28]; // \t\t\t\t\t</div>\n\t\t\t\t</div>\n\t\t\t</div>\n
#line 218 "whats_on.ecpp"

		} else { // mode == "list"
			std::list<EpgInfoPtr>::iterator last = i;
			bool lastCurrentChanel = (++last == eventList.end());
			tChannelID chanId;
			tEventID eventId;
			EpgEvents::DecodeDomId(epgEvent->Id(), chanId, eventId);

			// Searching for channel logos
			std::string chanlogoimg;
			if (!LiveSetup().GetChanLogoDir().empty() ) {
				std::string chanlogofile = StringReplace(epgEvent->Caption(), "/", "_") + ".png";
				std::string chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
				struct stat chanfilebuf;
        bool logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        if (!logo_available) {
          chanlogofile = std::string(cToSvToLower(chanlogofile, g_locale));
          chanlogopath = LiveSetup().GetChanLogoDir() + chanlogofile;
          logo_available = stat (chanlogopath.c_str(), &chanfilebuf) == 0;
        }
				if (logo_available) {
					chanlogoimg = "<img src=\"chanlogos/";
          AppendHtmlEscapedAndCorrectNonUTF8(chanlogoimg, chanlogofile);
          chanlogoimg.append("\" alt=\"");
          AppendHtmlEscapedAndCorrectNonUTF8(chanlogoimg, epgEvent->Caption());
          chanlogoimg.append("\" loading=\"lazy\" class=\"channel_logo\">");
				}
      }

  reply.out() << _tntChunks[29]; // \t\t\t<tr>\n\t\t\t\t
  // <& pageelems.epg_tool_box ...
  { 
#line 248 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 248 "whats_on.ecpp"
    _tnt_cq11.add( "detail", (0));
#line 248 "whats_on.ecpp"
    _tnt_cq11.add( "endTime", (epgEvent->GetEndTime()));
#line 248 "whats_on.ecpp"
    _tnt_cq11.add( "epgid", (epgEvent->Id()));
#line 248 "whats_on.ecpp"
    _tnt_cq11.add( "lastCurrentChanel", (lastCurrentChanel ? 1 : 0));
#line 248 "whats_on.ecpp"
    _tnt_cq11.add( "startTime", (epgEvent->GetStartTime()));
#line 248 "whats_on.ecpp"
    _tnt_cq11.add( "title", (epgEvent->Title()));
#line 248 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "epg_tool_box"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[30]; // \n\t\t\t\t<td class="topaligned 
#line 249 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[31]; // ">\n\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t<div class="nomargin nowrap">
#line 251 "whats_on.ecpp"
  reply.sout() << ( (timeSpan) );
  reply.out() << _tntChunks[32]; // </div>\n\t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 252 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 252 "whats_on.ecpp"
    _tnt_cq12.add( "duration", (epgEvent->Duration()));
#line 252 "whats_on.ecpp"
    _tnt_cq12.add( "progress", (epgEvent->Elapsed()));
#line 252 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[33]; // </div></div>\n\t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class="topaligned 
#line 255 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[34]; // ">\n
#line 256 "whats_on.ecpp"
					if (eventId != 0) {

  reply.out() << _tntChunks[35]; // \t\t\t\t\t\t<div class="more withmargin">\n\t\t\t\t\t\t<a\n
#line 259 "whats_on.ecpp"
						if (!longDescription.empty()) {

  reply.out() << _tntChunks[36]; // \t\t\t\t\t\t
  // <& tooltip.hint ...
  { 
#line 260 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 260 "whats_on.ecpp"
    _tnt_cq13.add( "text", (longDescription));
#line 260 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq13);
    // &>
  }
  // <& tooltip.display ...
  { 
#line 260 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 260 "whats_on.ecpp"
    _tnt_cq14.add( "domId", (epgEvent->Id()));
#line 260 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "display"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[37]; // \n
#line 261 "whats_on.ecpp"
						}

  reply.out() << _tntChunks[38]; // \t\t\t\t\t\t><span class="title">
#line 262 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[39]; // </span><br /><span class="short">
#line 262 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->ShortDescr()) );
  reply.out() << _tntChunks[40]; // </span></a>\n
#line 263 "whats_on.ecpp"
					} else {

  reply.out() << _tntChunks[41]; // \t\t\t\t\t\t<div class="withmargin">\n\t\t\t\t\t\t
#line 265 "whats_on.ecpp"
  reply.sout() << ( (epgEvent->Title()) );
  reply.out() << _tntChunks[42]; // \n
#line 266 "whats_on.ecpp"
					}

  reply.out() << _tntChunks[43]; // \t\t\t\t\t</div>\n\t\t\t\t</td>\n\t\t\t\t<td class="topaligned rightcol 
#line 269 "whats_on.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[44]; // "><div class="station withmargin"><a href="schedule.html\?channel=
#line 269 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
  reply.out() << _tntChunks[45]; // " 
  // <& tooltip.hint ...
  { 
#line 269 "whats_on.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 269 "whats_on.ecpp"
    _tnt_cq15.add( "text", (tr("View the schedule of this channel")));
#line 269 "whats_on.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[46]; // >
#line 269 "whats_on.ecpp"
  reply.sout() << ( cSv(cToSvInt(chNumber)) );
#line 269 "whats_on.ecpp"
  reply.sout() << ( tr(" - ") );
#line 269 "whats_on.ecpp"
  reply.out() << ( chanlogoimg );
#line 269 "whats_on.ecpp"
  reply.sout() << ( chanlogoimg.empty()?epgEvent->Caption():"" );
  reply.out() << _tntChunks[47]; // </a></div>\n\t\t\t\t</td>\n\t\t\t</tr>\n
#line 272 "whats_on.ecpp"
	}

#line 273 "whats_on.ecpp"

	}

#line 276 "whats_on.ecpp"
	if (mode == "list") {

  reply.out() << _tntChunks[48]; // \t\t\t</table>\n
#line 278 "whats_on.ecpp"
   }

  reply.out() << _tntChunks[49]; // \t\t</div>\n\t</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[50]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[51]; // \n
  reply.out() << _tntChunks[52]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::whats_on_actions_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("whats_on::whats_on_actions " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 21 "whats_on.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 26 "whats_on.ecpp"
  typedef std::string current_type_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_type, ());   // <%request> std::string current_type
  _tnt_ignore_unused<current_type_type>(current_type);
#line 27 "whats_on.ecpp"
  typedef std::string current_mode_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_mode, ());   // <%request> std::string current_mode
  _tnt_ignore_unused<current_mode_type>(current_mode);
#line 28 "whats_on.ecpp"
  typedef std::string current_attime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_attime, ());   // <%request> std::string current_attime
  _tnt_ignore_unused<current_attime_type>(current_attime);
#line 29 "whats_on.ecpp"
  typedef std::string current_fixtime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_fixtime, ());   // <%request> std::string current_fixtime
  _tnt_ignore_unused<current_fixtime_type>(current_fixtime);
#line 30 "whats_on.ecpp"
  typedef std::string current_displaytime_type;
  TNT_REQUEST_SHARED_VAR(std::string, current_displaytime, ());   // <%request> std::string current_displaytime
  _tnt_ignore_unused<current_displaytime_type>(current_displaytime);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[53]; // <a class="
#line 287 "whats_on.ecpp"
  if ( current_type == "now" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[54]; // " href="whats_on.html\?type=now&amp;mode=
#line 287 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[55]; // " id="nowhref">
#line 287 "whats_on.ecpp"
  reply.sout() << ( tr("Now") );
  reply.out() << _tntChunks[56]; // </a>\n<span class="sep">|</span>\n<a class="
#line 289 "whats_on.ecpp"
  if ( current_type == "next" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[57]; // " href="whats_on.html\?type=next&amp;mode=
#line 289 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[58]; // " id="nexthref">
#line 289 "whats_on.ecpp"
  reply.sout() << ( tr("Next") );
  reply.out() << _tntChunks[59]; // </a>\n<span class="sep">|</span>\n<span class="
#line 291 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime != "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[60]; // ">
#line 291 "whats_on.ecpp"
  reply.sout() << ( tr("What's on") );
  reply.out() << _tntChunks[61]; // </span>\n<select name="userdeftimes" size="1" id="userdeftimes" onchange="showtime(this)">\n\t<option value="0"/>\n
#line 294 "whats_on.ecpp"

	std::vector< std::string > parts = StringSplit( LiveSetup().GetTimes(), ';' );
	std::vector< std::string >::const_iterator part = parts.begin();
	for ( int i = 0; part != parts.end(); ++i, ++part ) {

  reply.out() << _tntChunks[62]; // \t<option 
#line 299 "whats_on.ecpp"
 reply.out() << ( (current_fixtime != "" && *part == current_displaytime) ? "selected=\"selected\"" : "" ); 
  reply.out() << _tntChunks[63]; // value="
#line 299 "whats_on.ecpp"
  reply.sout() << ( *part );
  reply.out() << _tntChunks[64]; // "> 
#line 299 "whats_on.ecpp"
  reply.sout() << ( tr("at") + std::string(" ") + *part );
  reply.out() << _tntChunks[65]; // </option>\n
#line 300 "whats_on.ecpp"

	}

  reply.out() << _tntChunks[66]; // </select>\n<span class="sep">|</span>\n<span class="
#line 305 "whats_on.ecpp"
  if ( current_type == "at" && current_fixtime == "" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[67]; // ">
#line 305 "whats_on.ecpp"
  reply.sout() << ( tr("at") );
  reply.out() << _tntChunks[68]; // </span>\n<input type="text" size="6" name="spectime" id="spectime" value = "
#line 306 "whats_on.ecpp"
  if ( current_attime != "" )
    reply.sout() <<  current_displaytime ;
  reply.out() << _tntChunks[69]; // " onchange="showspectime(this)"/>\n<span class="sep">|</span>\n
#line 308 "whats_on.ecpp"
 if ( LiveFeatures< features::epgsearch >().Recent() ) {

  reply.out() << _tntChunks[70]; // <a class="
#line 309 "whats_on.ecpp"
  if ( current_type == "favs" )
    reply.sout() <<  "active" ;
  reply.out() << _tntChunks[71]; // " href="whats_on.html\?type=favs&amp;mode=
#line 309 "whats_on.ecpp"
  reply.sout() << ( current_mode );
  reply.out() << _tntChunks[72]; // ">
#line 309 "whats_on.ecpp"
  reply.sout() << ( tr("Favorites") );
  reply.out() << _tntChunks[73]; // </a>\n<span class="sep">|</span>\n
#line 311 "whats_on.ecpp"
 }

#line 312 "whats_on.ecpp"
 if ( current_mode == "list" ) {

  reply.out() << _tntChunks[74]; // <a href="whats_on.html\?mode=detail&amp;type=
#line 313 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[75]; // &amp;attime=
#line 313 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[76]; // &amp;fixtime=
#line 313 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[77]; // ">
#line 313 "whats_on.ecpp"
  reply.sout() << ( tr("Details view") );
  reply.out() << _tntChunks[78]; // </a>\n
#line 314 "whats_on.ecpp"
 } else {

  reply.out() << _tntChunks[79]; // <a href="whats_on.html\?mode=list&amp;type=
#line 315 "whats_on.ecpp"
  reply.sout() << ( current_type );
  reply.out() << _tntChunks[80]; // &amp;attime=
#line 315 "whats_on.ecpp"
  reply.sout() << ( current_attime );
  reply.out() << _tntChunks[81]; // &amp;fixtime=
#line 315 "whats_on.ecpp"
  reply.sout() << ( current_fixtime );
  reply.out() << _tntChunks[82]; // ">
#line 315 "whats_on.ecpp"
  reply.sout() << ( tr("List view") );
  reply.out() << _tntChunks[83]; // </a>\n
#line 316 "whats_on.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

} // namespace
